﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;
using System.Reactive.Linq;

namespace SilverlightApplication1.Extensions
{
    public static class IEnumerableEx
    {
        public static IEnumerable<T> Do<T>(this IEnumerable<T> source, Action<T> action)
        {
            foreach (T item in source)
            {
                action(item);
                yield return item;
            }
        }

        //public static IObservable<T> ToObservable<T>(this IEnumerable<T> source)
        //{
        //    var obs = Observable.Create<T>(observer =>
        //        {
        //            try 
        //            {	        
        //                foreach (T item in source)
        //                    observer.OnNext(item);
        //                observer.OnCompleted();
        //            }
        //            catch (Exception ex)
        //            {
        //                observer.OnError(ex);
        //            }
        //            return () => { };
        //        });

        //    return obs;
        //}
    }
}
